『数位DP』POJ3971:Scales

2023-10-13 12:48
文章标签 dp 数位 poj3971 scales

本文主要是介绍『数位DP』POJ3971:Scales,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目描述

有一个物品重量为 w w w,现在你有 1 , 2 , 4 , … , 2 n 1,2,4,…,2^n 1,2,4,,2n重量的砝码,问有多少种方法可以使得天平平衡。

w w w以二进制给出。

题解

观察到砝码都是2的整次幂,在二进制中只有一位数是 1 1 1,其余都是 0 0 0.

我们可以将一组砝码的重量归为x,另一组为y,求满足如下条件的方案数: { x a n d y = 0 x + w = y \begin{cases} x\ and\ y=0\\ x+w=y \end{cases} {x and y=0x+w=y
因此我们就可以转化成这样的一个n为等式: □ □ □ □ □ □ □ □ □ □ + 01101011000 − − − − − − − − − − □ □ □ □ □ □ □ □ □ □ □□□□□□□□□□ \\+01101011000 \\---------- \\□□□□□□□□□□ +01101011000

其中每一列的方框只能填写至多一个1.

观察一下性质,我们可以使用数位DP来解决问题。设 f [ i ] [ 0 / 1 ] f[i][0/1] f[i][0/1]表示到第i位,满足条件,下一步是( 1 1 1)否( 0 0 0)产生进位的方案数。

当前位为 1 1 1时:假设上一位的进位情况为 l a s t last last,当前位填写的数位 x x x

  • 如果进位需要满足条件: x + l a s t + 0 > 1 x+last+0>1 x+last+0>1
    所有合法的解是: { x = 1 l a s t = 1 \begin{cases} x=1\\last=1\end{cases} {x=1last=1
    因此有转移方程: f [ i ] [ 1 ] = f [ i − 1 ] [ 1 ] f[i][1]=f[i-1][1] f[i][1]=f[i1][1]
  • 如果不进位,需要满足: x + l a s t + 0 ≤ 1 x+last+0\leq 1 x+last+01
    所有合法的解为: ① { x = 0 l a s t = 0 ② { x = 1 l a s t = 0 ③ { x = 0 l a s t = 1 ①\begin{cases}x=0\\last=0 \end{cases}②\begin{cases} x=1\\last=0\end{cases}③\begin{cases}x=0\\last=1 \end{cases} {x=0last=0{x=1last=0{x=0last=1
    所以状态转移方程有: f [ i ] [ j ] = f [ i − 1 ] [ 0 ] + f [ i − 1 ] [ 1 ] f[i][j]=f[i-1][0]+f[i-1][1] f[i][j]=f[i1][0]+f[i1][1]

若当前位位1,可以使用相同的推导方法很容易得到: f [ i ] [ 0 ] = f [ i − 1 ] [ 0 ] f [ i ] [ 1 ] = f [ i − 1 ] [ 0 ] + f [ i − 1 ] [ 1 ] f[i][0]=f[i-1][0]\\f[i][1]=f[i-1][0]+f[i-1][1] f[i][0]=f[i1][0]f[i][1]=f[i1][0]+f[i1][1]

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>using namespace std;
const int N = 2000000;char a[N];
int n, m, D;
int f[N][2];void init(void)
{cin>>n>>m>>D;memset(f,0,sizeof f);for (int i=1;i<=m;++i) cin>>a[i];reverse(a+1,a+m+1);for (int i=m+1;i<=n;++i) a[i] = 48;return;
}void DP(void)
{#define upd(a,b) (a=(a+b)%D)f[0][0] = 1;for (int i=1;i<=n;++i){if (a[i] == 48) {upd(f[i][0],f[i-1][0]+f[i-1][1]);upd(f[i][1],f[i-1][1]);}else {upd(f[i][0],f[i-1][0]);upd(f[i][1],f[i-1][0]+f[i-1][1]);}}cout<<f[n][0]<<endl;return;
}void work(void)
{init();DP();return;
}int main(void)
{int T; cin>>T;while (T --) work();return 0;
}

这篇关于『数位DP』POJ3971:Scales的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/203322

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o

dp算法练习题【8】

不同二叉搜索树 96. 不同的二叉搜索树 给你一个整数 n ,求恰由 n 个节点组成且节点值从 1 到 n 互不相同的 二叉搜索树 有多少种?返回满足题意的二叉搜索树的种数。 示例 1: 输入:n = 3输出:5 示例 2: 输入:n = 1输出:1 class Solution {public int numTrees(int n) {int[] dp = new int